      SUBROUTINE INIT
C
C     THIS SUBROUTINE SETS MOST VARIABLES IN THE COMMON BLOCKS TO 0.
C
C&
      INCLUDE "comsm2.f"
C
      DO 100 I=1,NCOLMX
         KINBAS(I) = 0
  100 CONTINUE
      DO 101 I=1,NAMAX
         A(I)  = 0.0
         IA(I) = 0
  101 CONTINUE
      DO 102 I=1,NROWMX
         JH(I)  = 0
         B(I)   = 0.0
         X(I)   = 0.0
         YPI(I) = 0.0
  102 CONTINUE
      DO 103 I=1,NEMAX
         E(I)  = 0.0
         IE(I) = 0
         XI(I) = 0.0
  103 CONTINUE
      DO 104 I=1,NBMAX
         KCOLA(I) = 0
         KELMA(I) = 0
         NELMA(I) = 0
  104 CONTINUE
      DO 110 I=1,3000
         LA(I)  = 0
         XLB(I) = 0.D0
         XUB(I) = 0.D0
  110 CONTINUE
      DO 120 I=1,2000
         NCOL(I)   = 0
         NROW(I)   = 0
         NCUT(I)   = 0
         LINKUT(I) = 0
         ICUT1(I)  = 0
         KCOL(I)   = 0
         KCOST(I)  = 0
         KROW(I)   = 0
         KRHS(I)   = 0
         KBOUND(I) = 0
         KNAMES(I) = 0
         IANCTR(I) = 0
         IBROTH(I) = 0
         IDESC(I)  = 0
         NDESC(I)  = 0
         KDATA(I)  = 0
         PROB(I)   = 0.0
  120 CONTINUE
      DO 130 I=1,1001
         LE(I) = 0
  130 CONTINUE
      DO 150 L=1,10
         IRNGE0(L) = 0
         IRNGE1(L) = 0
         IRNGE2(L) = 0
  150 CONTINUE
c     DO 160 I=1,10
c     DO 160 J=1,10
c        IASTO(I,J) = 0
c 160 CONTINUE
      DE     = 0.0
      DP     = 0.0
      IBASIS = 0
      IDIR   = 0
      IDUAL  = 0
      IOBJ   = 0
      IROWP  = 0
      ITCNT  = 0
      INVFRQ = 0
      ISTOCH = 0
      ITRFRQ = 0
      JCOLP  = 0
      MAXCOL = 0
      MAXROW = 0
      NETA   = 0
      NLELEM = 0
      NLETA  = 0
      NUELEM = 0
      NUETA  = 0
      NELEM  = 0
      NPASS  = 0
      IPER   = 0
      JPASS  = 0
      JVRSN  = 0
      NREADB = 0
      NPER   = 0
      INFLAG = 0
      INDEP  = 0
      dblank='        '
      dsimpl='SIMPLE  '
      dots  ='  ...   '
      discr ='DISCRETE'
      dper1 ='PERIOD1 '
      dxi   ='RHS     '
      dbound='BOUND   '
      dRANGE='RANGE   '
      ZTOLZE=1.d-12
      RETURN
      END
C .....................................................................
C
C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C
      BLOCK DATA
C
C        INITIALIZES GLOBAL PROGRAM CONSTANTS
C        SUBROUTINE ADAPTED FROM LINEAR PROGRAMMING CODE LPM-1, WRITTEN
C        BY J.A. TOMLIN (OPERATIONS RESEARCH, STANFORD UNIVERSITY),
C        MODIFIED FROM STOCHASTIC PROGRAMMING CODE NDSP, WRITTEN BY
C        JOHN BIRGE (INDUSTRIAL ENGINEERING, UNIVERSITY OF MICHIGAN)
C
C
      INCLUDE "comsm2.f"
C
      DATA QBL /' '/, QA  /'A'/, QB  /'B'/, QC  /'C'/, QD  /'D'/,
     *     QE  /'E'/, QF  /'F'/, QG  /'G'/, QH  /'H'/, QI  /'I'/,
     *     QK  /'K'/, QL  /'L'/, QM  /'M'/, QN  /'N'/, QO  /'O'/,
     *     QP  /'P'/, QR  /'R'/, QS  /'S'/, QT  /'T'/, QU  /'U'/,
     *     QX  /'X'/, QAST/'*'/
C
      END
