C-------------------------------------------------------------------------
C Subroutine : putnode : writes the relevant information for node inode.
C                        to fioels iowric, etc.
C
C mode = 1:  Write objective row, mode = 2,  not!
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTNODE(MODE,INODE0)
      INCLUDE "comsm2.f"
      CHARACTER*8 DRNAM, DCNAM, NMTEMP
      CHARACTER*1 TYPE
      INTEGER*4 I0FOCUS
C
C     -------------------------------------------- : Set paramters
      CALL PTRMAP
C     -------------------------------------------- : Find LEVEL and probs
C
      I0BAK = INODE
      I0  = INODE
      DO 10 LEVEL=1,NPER
         I0=IANCTR(I0)
         IF(I0.EQ.0) GOTO 11
 10   CONTINUE
      WRITE(IOLOG,3800)
      CALL STOPIT
C
 11   CONTINUE
      level=nper-level+1
c     NMTEMP=NAMES(IOBJ)
c     WRITE(NAMES(IOBJ),4005) NMTEMP
c4005 FORMAT(A6,'00')
      I0 = I0BAK
      I0FOCUS=I0
C
C     -------------------------------------------- : Extract Rows
      IROW   = KROW(I0)
      NROWS  = NROW(I0)
      IBOUND = KBOUND(I0)
      INAMES = KNAMES(I0)
C
      IF(INODE.NE.INODE0.AND.INODE0.GE.1) GOTO  60
      DO 50 IR=1,NROWS
         IF (IR .EQ. IOBJ) THEN
            IF( IFMT.GE.3.or.i0.eq.1) then
               CALL MAKENAME(DRNAM, 0, IR, NAMES(INAMES+IR),'R')
               TYPE=QN
               WRITE(IOWRIR,4000) TYPE,DRNAM
            endif
         ELSE
            CALL MAKENAME(DRNAM, I0FOCUS, IR, NAMES(INAMES+IR),'R')
            XUPPER = XUB(IBOUND+IR)
            XLOWER = XLB(IBOUND+IR)
            IF (XUPPER .GT.  1.) THEN
               TYPE = QL
            ELSE IF (XLOWER .LT. -1.) THEN
               TYPE = QG
            ELSE IF(XUPPER - XLOWER .LT. ZTOLZE) THEN
               TYPE = QE
            ELSE
               TYPE = QN
            ENDIF
            WRITE (IOWRIR, 4000) TYPE, DRNAM
         ENDIF
   50 CONTINUE

C
C     -------------------------------------------- : Extract columns
C     Here's hoping that this code works.
 60   NMTX=LEVEL
      IF(MARKOV.AND.LEVEL.GT.2) NMTX=2
      DO 180 JC=NROWS+1,NCOLS
         INODE = I0
         LMTX  = 1
         CALL MAKENAME(DCNAM,I0FOCUS,JC,NAMES(INAMES+JC),'C')
  110    CONTINUE
            IF( IFMT.GE.3.AND.IFMT.LE.5.AND.
     *         INODE0.GE.1.AND.INODE.NE.INODE0) GOTO 145
            JROWS  = NROW(INODE)
            JNAMES = KNAMES(INODE)
            CALL PTRMAP
            CALL UNPACK(JC,LMTX)
C                                                  : Find Row
            DO 140 JR=1,JROWS
               IF (DABS(Y(JR)) .GT. ZTOLZE) THEN
                  IF (JR .NE. IOBJ) THEN
                     CALL MAKENAME(DRNAM,INODE,JR,NAMES(JNAMES+JR),'R')
                     WRITE (IOWRIC, 4050) DCNAM, DRNAM, Y(JR)
                  ELSE
                     CALL MAKENAME( DRNAM, 0, JR, NAMES(JR),'R')
                     WRITE (IOWRIC,4060) DCNAM, DRNAM, Y(JR)*PROB(I0)
                  ENDIF
               ENDIF
  140       CONTINUE
C                                                  :Find new matrix
  145       IF (IDESC(INODE) .GT. 0 .AND. LMTX .LT. NMTX) GOTO 160
            IF (INODE .EQ. I0 .or. ifmt.eq.2) GOTO 180
  150       CONTINUE
               IF (IBROTH(INODE) .GT.  0) GOTO 170
               IF (IANCTR(INODE) .EQ. I0) GOTO 180
                  INODE = IANCTR(INODE)
                  LMTX = LMTX - 1
                  GOTO 150
  160       CONTINUE
               INODE = IDESC(INODE)
               LMTX = LMTX + 1
               GOTO 110
  170       CONTINUE
               INODE = IBROTH(INODE)
               GOTO 110
  180 CONTINUE
C
C     -------------------------------------------- : Extract rhs
C
      IF(I0BAK.NE.INODE0.AND.INODE0.GE.1) GOTO 400
      I0=I0BAK
      DO 208 IR = 1,NROW(I0)
         IROW = KRHS(I0) + IR
         IF (DABS(XI(IROW)) .GT. ZTOLZE) THEN
            CALL MAKENAME(DRNAM, I0FOCUS, IR, NAMES(KNAMES(I0)+IR),'R')
            WRITE (IOWRIB,4080) DRNAM,  XI(IROW)
         ENDIF
  208 CONTINUE
  400 INODE = I0BAK
      RETURN
C
 3800 FORMAT(' ERROR: No descendant!!')
 4000 FORMAT(' ',A1,2X,A8)
 4050 FORMAT(4X,A8,2X,A8,2X,G12.6)
 4060 FORMAT(4X,A8,2X,A8,2X,G12.6)
 4080 FORMAT(4X,'RHS',7X,A8,2X,G12.6)
C
      END
C-------------------------------------------------------------------------
C Subroutine : putIDEN : writes the identity rows/cols for fmt=2
C-------------------------------------------------------------------------
C-------------------------------------------------------------------------
C Subroutine : putIDEN : writes the identity rows/cols for fmt=2
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTIDEN
      INCLUDE "comsm2.f"
      CHARACTER*8 DRNAM, DCNAM
      CHARACTER*1 P1, P2, P3, P4, P5, P6, PA, PB
C
      WRITE(0,*) ' -- WARNING: CAN ONLY HANDLE SMALL 2-STAGE PROBS. -'
         NPOSS=NODES-1
         ISIZEI=NCOL(1)-NROW(1)
         DO 528 I=1,NPOSS
            CALL PDTOASCII(I,P1,P2)
            DO 525 J=1,ISIZEI
               CALL PDTOASCII(J,P3,P4)
               WRITE(IOWRIR,1100) P3,P4,P1,P2
 525        CONTINUE
 528     CONTINUE
C                                                  : I,T cols under A
C
         IOFFST=KNAMES(1)+NROW(1)
 530     DO 531 I=1,ISIZEI
            CALL PDTOASCII(I,P1,P2)
            WRITE(IOWRIC,1101) NAMES(IOFFST+I), P1,P2
 531     CONTINUE
C                                                  : T Cols, -I(n), I(n) cols
C                                                  : If IPtest=2, at end
         IPTEST=1
 535     DO 550 I=1,NPOSS
           IP=I+1
           IF(IP.GT.NPOSS) IPTEST=2
C                                                  : -I and T, row blk for I
           CALL PDTOASCII(I,P1,P2)
           CALL PDTOASCII(IP,P5,P6)
C                                                  : -I AND I
 542       DO 545 J=1,ISIZEI
              CALL PDTOASCII(J,P3,P4)
              WRITE(IOWRIC,1110) NAMES(IOFFST+J),P1,P2,P3,P4,
     *             P1,P2
              IF (IPTEST.EQ.1) THEN
                 WRITE(IOWRIC,1111) NAMES(IOFFST+J),P1,P2,P3,
     *             P4,P5,P6
              ENDIF
 545       CONTINUE
C
 550     CONTINUE
         RETURN
 1100 FORMAT(1X,'E',2X,'III',2A1,'I',2A1)
 1101 FORMAT(4X,A6,'00',2X,'III',2A1,'I01',2X,'    1.000000')
C
 1110 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'   -1.000000')
 1111 FORMAT(4X,A6,2A1,2X,'III',2A1,'I',2A1,2X,'    1.000000')
         END
C
C-------------------------------------------------------------------------
C Subroutine : putmod  : writes the sorted information as an mps model
C
C arguments: irwunit, iclunit, irhsunit
C-------------------------------------------------------------------------
C
      SUBROUTINE PUTMOD(IRWU,ICLU,PROBNM)
      INCLUDE "comsm2.f"
      CHARACTER*8 DN1BAK, DN2BAK
      COMMON /COLTMP/ DN1BAK, DN2BAK, AVALBAK, IRECNO
C
      CHARACTER*8 PROBNM, DNAME(3)
C
      IRECNO=1
C     -------------------------------------------- : Form Problem Name
      IF(IFMT.GE.3.AND.IFMT.LE.5) THEN
         CALL PDTOASCII(INODE,PER1,PER2)
            IF(NODES.LE.9) THEN
               WRITE(IOSOL,"('NAME',10X,A6,'.',I1,'.',2A1)")
     *           PROBNM, NPOSS,PER1,PER2
            ELSE
               WRITE(IOSOL,"('NAME',10X,A6,'.',I2,'.',2A1)")
     *           PROBNM, NPOSS,PER1,PER2
            ENDIF
      ELSE
         WRITE (IOSOL, 4000) PROBNM
      ENDIF
C     -------------------------------------------- : Rest of data
      WRITE (IOSOL, 4010)
C
 720     READ (IRWU, 1201, ERR=732,END=722)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         WRITE(IOSOL,1206) Q1,Q2,Q3,Q4,DNAME(1)
         GOTO 720
 722  WRITE(IOSOL,1202)
      IRECNO=1
 723     READ (ICLU, 1201, ERR=732,END=724)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         CALL COLREC(1,IOSOL,Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1)
         GOTO 723
 724  CALL COLREC(3,IOSOL,Q1,Q2,Q3,Q4,'        ','        ',1.0)
      WRITE(IOSOL,1203)
      IRECNO=1
 725     READ (IOWRIB,1201, ERR=732,END=726)
     *      Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1
         CALL COLREC(1,IOSOL,Q1,Q2,Q3,Q4,DNAME(1),DNAME(2),ATEMP1)
         GOTO 725
 726  CALL COLREC(3,IOSOL,Q1,Q2,Q3,Q4,'        ','        ',1.0)
      WRITE(IOSOL,1204)
      RETURN
 732  WRITE(IOLOG,*) ' ERROR WRITING FILES!!!!'
      CALL STOPIT
      RETURN
C
 1200 FORMAT('NAME'/'ROWS ')
 1201 FORMAT(4A1,A8,2X,A8,2X,F12.4)
 1202 FORMAT('COLUMNS')
 1203 FORMAT('RHS')
 1204 FORMAT('ENDATA')
 1206 FORMAT(4A1,A8)
 4000 FORMAT('NAME',10X,A8)
 4005 FORMAT(A6,'00')
 4010 FORMAT('ROWS')
 4020 FORMAT(' N  ',A6,'00')
 4040 FORMAT('COLUMNS')
 4070 FORMAT('RHS')
 4090 FORMAT('ENDATA')
C
      END
C-------------------------------------------------------------------------
C Subroutine : colrec  : writes columns in two-wide format. Neat!!
C       mode: 1: cols, 2: rhs, 3: flush
C arguments: irwunit, iclunit, irhsunit
C-------------------------------------------------------------------------
      SUBROUTINE COLREC(IMODE,IUNIT,Q1,Q2,Q3,Q4,DNAME1,DNAME2, AVAL)
      CHARACTER*1 Q1,Q2,Q3,Q4
      CHARACTER*8 DNAME1, DNAME2, DN1BAK, DN2BAK
      REAL*8 AVAL, AVALBAK
      INTEGER IUNIT, IRECNO, IMODE
      COMMON /COLTMP/ DN1BAK, DN2BAK, AVALBAK, IRECNO
c
      IF(IMODE.EQ.3) THEN
         IF(DN1BAK.NE.'        ') THEN
            WRITE(IUNIT,1201) DN1BAK, DN2BAK, AVALBAK
            DN1BAK='        '
            DN2BAK='        '
            AVALBAK=0.D0
         ENDIF
         RETURN
      ENDIF
      IF(DABS(AVAL).LE.1.D-10) RETURN
      IF(IRECNO.EQ.1) THEN
         DN1BAK='        '
         DN2BAK='        '
         AVALBAK=0.D0
      ENDIF
C        ... Now compare to previous one..
      IF(DN1BAK.NE.DNAME1) THEN
         IF(DN1BAK.NE.'        ') THEN
            WRITE(IUNIT,1201) DN1BAK, DN2BAK, AVALBAK
         ENDIF
         DN1BAK=DNAME1
         DN2BAK=DNAME2
         AVALBAK=AVAL
      ELSE
         WRITE(IUNIT,1202) DN1BAK, DN2BAK, AVALBAK, DNAME2, AVAL
         DN1BAK='        '
         DN2BAK='        '
         AVALBAK=0.D0
      ENDIF
      IRECNO=IRECNO+1
 1201 FORMAT(4(' '),A8,2X,A8,2X,G12.6)
 1202 FORMAT(4(' '),A8,2X,A8,2X,G12.6,3X,A8,2X,G12.6)
      RETURN
      END
C-------------------------------------------------------------------------
C     MAKENAME    converts node and row and name into name for
C                 printind
C-------------------------------------------------------------------------
      SUBROUTINE MAKENAME(NAMEOUT, INODE, IROW, NAMEIN, TYPE)
C
      CHARACTER*8 DXI, DBOUND, DRANGE, dblank, dsimpl, dots,
     *            discr, dper1, NAMEOUT
      CHARACTER*8 NAMEIN
      CHARACTER*1 CODE(36), TYPE

      INTEGER*4  INODE, IROW, I1, I2, IREMROW, IREMNODE, IREM

      LOGICAL*4   nameno

      common /misc/ dblank, dsimpl, dots, discr, dxi, dper1,
     *              dbound, drange, nposs, ifmt, nameno, mxndflds

      DATA CODE/ '0','1','2','3','4','5','6','7','8','9','A','B',
     *           'C','D','E','F','G','H','I','J','K','L','M','N',
     *           'O','P','Q','R','S','T','U','V','W','X','Y','Z'/
C
      IF( .NOT.(NAMENO)) THEN
        MXNMFLDS=6
      ELSE
        MXNMFLDS=7-MXNDFLDS
      ENDIF
      NAMEOUT='        '
      IREMROW  = IROW
      IREMNODE = INODE

      DO 10 IPOS=1,8
         IF( .not.(nameno) ) THEN
             IF( IPOS.LE.6 ) THEN
                 NAMEOUT(IPOS:IPOS)=NAMEIN(IPOS:IPOS)
             ELSE
                IREM= IREMNODE/(36**(8-IPOS))
                NAMEOUT(IPOS:IPOS)=CODE(IREM+1)
                IREMNODE=IREMNODE-IREM*(36**(8-IPOS))
             ENDIF
         ELSE
            IF( IPOS.EQ.1 ) THEN
               NAMEOUT(IPOS:IPOS)=TYPE
            ELSE IF(IPOS.GT.1.AND.IPOS.LE.MXNMFLDS+1) THEN
               IEXP = MXNMFLDS+1 - IPOS 
               IREM = IREMROW/(36**IEXP)
               NAMEOUT(IPOS:IPOS) = CODE(IREM+1)
               IREMROW = IREMROW - IREM*(36**IEXP)
            ELSE IF (IPOS.GE.MXNMFLDS+1) THEN
               IEXP = 8 - IPOS
               IREM = IREMNODE/(36**IEXP)
               NAMEOUT(IPOS:IPOS) = CODE(IREM+1)
               IREMNODE = IREMNODE - IREM*(36**IEXP)
            ENDIF
         ENDIF
 10   CONTINUE
      RETURN
      END
C-------------------------------------------------------------------------
C      PDTOASCII converts node number I into two character codes C1 and C2
C                 Notes: Ripe for inlining!!!
C-------------------------------------------------------------------------
      SUBROUTINE PDTOASCII(I,C1,C2)
C
      INTEGER I, I1, I2
      CHARACTER*1 CODE(36), C1, C2
      DATA CODE/ '0','1','2','3','4','5','6','7','8','9','A','B',
     *           'C','D','E','F','G','H','I','J','K','L','M','N',
     *           'O','P','Q','R','S','T','U','V','W','X','Y','Z'/
C
      I1=I/36
      IF (I1.GE.36) THEN
        WRITE(0,*) ' ERROR: PDTOASCII LIMITS EXCEEDED: NODE: ',I
        STOP
      ENDIF
      I2=I-I1*36
      C1=CODE(I1+1)
      C2=CODE(I2+1)
      RETURN
      END
